package com.szpg.task;

import com.szpg.db.dao.impl.PgAcuRdcmdDaoImpl;
import com.szpg.db.data.PgAcuRdcmd;
import com.szpg.plc.message.AppCommand;
import com.szpg.plc.message.command.read.ReadHSStatusCommand;
import com.szpg.plc.protocol.DTProtocolInterface;
import com.szpg.plc.protocol.ProtocolFactory;
import com.szpg.plc.server.ACUClient;
import com.szpg.plc.server.ACUClientUtil;
import com.szpg.plc.util.ByteUtil;

public class ReadHSStatusTask implements Runnable {

	private ACUClient client;
	private AppCommand appCommand;

	public ReadHSStatusTask(ACUClient client, AppCommand command) {
		this.client = client;
		this.appCommand = command;
	}

	@Override
	public void run() {
		DTProtocolInterface finspi = ProtocolFactory.getDefaultDTProtocol();
		byte[] content = finspi.messageToBytes(appCommand);
		
		// 发送读取硫化氢参数内存命令
		ACUClientUtil.getInstance().sendACUCommand(client, content);
		
		ReadHSStatusCommand hsAlmCmd = (ReadHSStatusCommand) appCommand;

		// 发送完成之后将命令保存在数据库中
		PgAcuRdcmd cmd = new PgAcuRdcmd();
		cmd.setCmd_type(hsAlmCmd.getCommandType());
		cmd.setDest(hsAlmCmd.getDestinationId());
		cmd.setMem_area_cd(ByteUtil.binToHexString(new byte[] { hsAlmCmd.getMemoryArea() }));
		cmd.setStart_mem_word(hsAlmCmd.getStartAddress().substring(0, 4));
		cmd.setStart_mem_bit(hsAlmCmd.getStartAddress().substring(4));
		cmd.setCount_word(hsAlmCmd.getCountWord());
		cmd.setCount_bit(hsAlmCmd.getCountBit());
		cmd.setCount_sensor(hsAlmCmd.getCountSensor());
		
		new PgAcuRdcmdDaoImpl().addCmdRecord(cmd);
	}

}
